Request

Response

    Main Contract Items
    GET

    v1/containers/{containerId}/main-contracts/{mainContractId}/items

    Retrieves one or more items in the specified main contracts.

    Note that this endpoint is compatible with both BIM 360 and Forma projects.

    Resource Information

    Method and URI
    GET
    https://developer.api.autodesk.com/cost/v1/containers/:containerId/main-contracts/:mainContractId/items
    Authentication Context
    User context required
    Required OAuth Scopes
    data:read
    Data Format
    JSON

    Request

    Headers

    Authorization*
    string
    Must be Bearer <token>, where <token> is a three-legged access token obtained via an Authorization Code flow or a Secure Service Account (SSA) flow.

    The SSA flow is designed for headless server-to-server operations. While it functions like a two-legged flow (no user interaction), it is classified as three-legged because it preserves user context.

    region
    string
    Specifies the region where the project data resides.

    By default, the request is routed automatically. However, specifying the region can improve performance by avoiding lookup overhead.

    Possible values: country or region codes such as US or EMEA. For the full list of supported regions, see the Forma Regions page.

    To verify your project’s region, refer to the Working with BIM 360 Services in Different Regions section on the API Basics page.

    * Required

    Request

    URI Parameters

    containerId
    string: UUID
    The ID of the project (the container ID is the same as the project ID). To obtain the project ID, see GET projects.
    mainContractId
    array: string: uuid
    A list of the IDs of the main contracts from which to return items, separated by commas. To find the main contract IDs, call GET main-contracts and inspect results.id in the response.

    Request

    Query String Parameters

    filter[id]
    array: string: uuid
    Returns only the items that are identified by the provided list of item IDs. Separate multiple IDs with commas. For example, filter[id]=id1,id2.
    include
    array: string
    A list of the types of nested resources to include in the response with the main contract items, separated by commas.

    For example, include=budget returns the budgets that are associated with each returned main contract item.

    Possible values: budget, mainContract.

    limit
    int
    The maximum number of records returned per page. Default: 100. A page may contain fewer records than the limit if there are fewer matching items or if it is the last page of results.
    offset
    int
    The number of records to skip before returning results. Used together with limit to paginate through results, where offset specifies the starting point and limit specifies the number of records to return.
    sort
    string
    Sorts main contract item results by a main-contract-item-level field in ascending or descending order. Supported fields: id, mainContractId, budgetId, parentId, code, name, description, quantity, unitPrice, unit, amount, createdAt, updatedAt, isPrivate, integrationState, integrationStateChangedAt, integrationStateChangedBy, position, externalSystem, externalId, lastSyncTime, externalMessage. Multiple comma separated attributes are supported. Each attribute can be sorted in asc (default) or desc order. For example, sort=name,createdAt desc.
    filter[externalSystem]
    string
    Filters results to only include items from the specified external ERP system. Use this to identify or search for items synchronized from a particular integrated system. For example, filter[externalSystem]=Sage300.

    Max length: 255

    filter[externalId]
    array: string
    Filters results to only include items identified by the specified external ERP system IDs. Use this ID to track or correlate data with an integrated ERP system. Separate multiple IDs with commas. For example, filter[externalId]=id1,id2.

    Response

    HTTP Status Code Summary

    200
    OK
    Success
    400
    Bad Request
    The parameters are invalid.
    401
    Unauthorized
    The provided bearer token is invalid.
    403
    Forbidden
    Forbidden. The user or service represented by the bearer token does not have permission to perform this operation.
    404
    Not Found
    The resource or endpoint cannot be found.
    409
    Conflict
    The request could not be completed due to a conflict with the current state of the resource.
    429
    Too Many Requests
    Rate limit exceeded. Retry your request after a few minutes.
    500
    Internal Server Error
    An unexpected error occurred on the server.
    503
    Service Unavailable
    Service unavailable.

    Response

    Body Structure (200)

    Expand all
    pagination
    object
    Contains pagination information when data is returned page by page.
    limit
    int
    The maximum number of records returned in the response.
    offset
    int
    The number of records skipped before returning the page of results.
    totalResults
    int
    The total number of records that matched the request criteria.
    nextUrl
    string
    The URL for the next request to retrieve the next page of results. Max length: 2000.

    Max length: 2000

    results
    array: object
    The contents of a record returned by this endpoint.
    id
    string
    The ID of the main contract item.
    budgetId
    string,null
    The ID of the budget linked to the main contract item.
    containerId
    string,null
    The ID of the cost container for the project. Each project is assigned a container that stores all of the cost data for the project.
    parentId
    string,null
    The ID of the parent item of the returned main contract item. This is used only when creating a main contract item.
    mainContractId
    string,null
    The ID of the main contract that contains the returned main contract item. This is used only when creating a main contract item.
    code
    string
    The code of the main contract item.

    Max length: 255

    name
    string
    The name of the main contract item.

    Max length: 1024

    description
    string
    A description of the main contract item.

    Max length: 2048

    unit
    string,null
    The unit of measure of the main contract item.

    Max length: 255

    unitPrice
    number,string,null
    The unit price of the main contract item.
    quantity
    number,string,null
    The quantity of the main contract item.
    amount
    number,string,null
    The total price of the main contract item.
    createdAt
    datetime: ISO 8601
    The date and time when the main contract item was created, in ISO 8601 format.
    updatedAt
    datetime: ISO 8601
    The date and time when the main contract item was last updated, in ISO 8601 format.
    isPrivate
    boolean,null
    true: The main contract item is private.

    false: The main contract item is not private.

    position
    int
    The position of the main contract item in its siblings of main contract items.
    externalId
    string
    The identifier assigned to an item in its original external ERP system. Use this ID to track and look up data within the integrated system. Note that this value comes from the item’s ID in the external system.

    Max length: 255

    externalSystem
    string
    The name of the external ERP system integrated with Cost Management. Use this name to identify and search for data within the integrated system.

    Max length: 255

    externalMessage
    string
    A message generated by the external ERP system that explains the sync status of the integration. For example, common values include success or fail to indicate the result of the integration operation.

    Max length: 255

    lastSyncTime
    datetime: ISO 8601
    The date and time when the item was last synchronized with the external ERP system. This value is updated by the external system and is in ISO 8601 format.
    integrationState
    string,null
    The state of the item during the integration with the external ERP system (such as SignNow). An item can be a budget, contract, main contract, main contract item, cost item, expense, expense item, change order, or schedule of value. For more details, see Integrate with External System tutorial. Possible values:

    locked: the item is currently locked within the ERP system, preventing modifications until unlocked. To unlock and modify the item, use the relevant PATCH endpoint to set integrationState to null. For example, for a budget, call PATCH budgets. For a contract, call PATCH contracts. For more details, see the Help documentation.

    integrated: the item has been successfully added to the ERP system.

    failed: the item encountered an error during the integration process and was not successfully added to the ERP system. For example, if a user tries to integrate contracts from an ERP system and the updates fail, the integrationState can be set to failed. Retry the sync process or analyze the issue if it continues to fail.

    null: The item has not been integrated with the ERP system. This is default value.

    For more information regarding integrations within the Cost Management system, see Integrations in Cost Management.

    integrationStateChangedAt
    string,null
    The date and time that the item’s integration status was last changed.
    integrationStateChangedBy
    string,null
    The user who last changed the integration status. This is the ID of a user managed by the BIM 360/Forma Admin.
    bridgeInfo
    object,null
    Not relevant

    Example

    Success

    Request

    curl -v 'https://developer.api.autodesk.com/cost/v1/containers/e94b9bc8-1775-4d76-9b1d-c613e120ccff/main-contracts/b6445638-ca68-4e3c-9160-15864de6b818/items?limit=100&sort=name,createdAt desc' \
      -H 'Authorization: Bearer AuIPTf4KYLTYGVnOHQ0cuolwCW2a'
    

    Response

    {
      "pagination": {
        "limit": 20,
        "offset": 0,
        "totalResults": 1,
        "nextUrl": ""
      },
      "results": [
        {
          "id": "1df59db0-9484-11e8-a7ec-7ddae203e404",
          "budgetId": "fc1f46d3-7838-11e8-a467-7de33c3af32d",
          "containerId": "e94b9bc8-1775-4d76-9b1d-c613e120ccff",
          "parentId": "36d8d230-0030-4bd6-a57c-ac4be8a891c9",
          "mainContractId": "f6445638-ca68-4e3c-9160-15864de6b818",
          "code": 1011,
          "name": "Site Management Staff",
          "description": "Site Management Staff",
          "unit": "ea",
          "unitPrice": "1000.0000",
          "quantity": "1000.0000",
          "amount": "1000.0000",
          "createdAt": "2019-08-22",
          "updatedAt": "2019-08-22",
          "isPrivate": true,
          "position": 1,
          "externalId": "10010-99-AB",
          "externalSystem": "Sage300",
          "externalMessage": "Success.",
          "lastSyncTime": "2019-09-05T01:00:12.989Z",
          "integrationState": "locked",
          "integrationStateChangedAt": "2019-09-05T01:00:12.989Z",
          "integrationStateChangedBy": "CED9LVTLHNXV",
          "bridgeInfo": ""
        }
      ]
    }
    
    Show More